//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Global-Variables:
int     i,Magic=777,Buy_Max=99,Sel_Max=99,Cross_Band;
double  Lots, Ans, Point2Pip, Slippage, Broker_Min, Broker_Max;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Init-Function:
int init(){
//~~~~~~~~~~
    Slippage=     MarketInfo(Symbol(),MODE_SPREAD);
    Broker_Max=   MarketInfo(Symbol(),MODE_MAXLOT);
    Broker_Min=   MarketInfo(Symbol(),MODE_MINLOT);
    //~~~~~~~~~~Point2Pip:
    Point2Pip=Point;
    if(Digits==3){Point2Pip=0.01;}
    if(Digits==5){Point2Pip=0.0001;}
//~~~~~~~~~~
return(0);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Start-Function:
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int start(){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Money Management:
if(AccountEquity()<3000){
    OrderSelect0(0,'t');Alert("No Trading <$3,000 for margin");
return(0);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Variable-PreSets:
Ans=0; Lots=0.1; if(Broker_Min>0.1){Lots=Broker_Min;}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~My-Comments:
Comment(
  "Account_Equity=",AccountEquity(),"\n"
);
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Get Indicator Values;
double UpperBand=iBands(NULL,PERIOD_M15,144,2,0,PRICE_WEIGHTED,MODE_UPPER,0);
double LowerBand=iBands(NULL,PERIOD_M15,144,2,0,PRICE_WEIGHTED,MODE_LOWER,0);
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~System Algorithm;
if(Bid>UpperBand){Cross_Band= 1;}
if(Ask<LowerBand){Cross_Band=-1;}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~OrderSend & Notification;
if(iVolume(NULL,PERIOD_M15,0)==1){
    if(Cross_Band== 1 && UpperBand>Open[0]){
        if(Send_Mkt(-Magic)>0){Alert("We are going Short.");Cross_Band=0;}
    }
    if(Cross_Band==-1 && LowerBand<Open[0]){
        if(Send_Mkt( Magic)>0){Alert("We are going Long..");Cross_Band=0;}
    }
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~OrderClose & Notification;
if(OrderSelect0(Magic,'m')>0){
    if(Bid>=UpperBand){
        OrderSelect0(Magic,'a');
        if(OrderSelect0(Magic,'m')<1){Alert("All Long  Positions Closed");}
    }
}
if(OrderSelect0(-Magic,'m')>0){
    if(Ask<=LowerBand){
        OrderSelect0(-Magic,'a');
        if(OrderSelect0(-Magic,'m')<1){Alert("All Short Positions Closed");}
    }
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
return(0);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~User_Defined-Functions:
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Send_Mkt-Function
int Send_Mkt(int Magic){
//~~~~~~~~~~
    string Str_Magic;
    //~~~~~~~~~~
    if(Magic>0){
        if(OrderSelect0(Magic,'m')>=Buy_Max){Magic=0;}}
    if(Magic>0){
        Str_Magic="Buy_Magic= "+DoubleToStr(Magic,0);
        Ans=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,
        0,0,Str_Magic,Magic,0,Blue);
    }
    //~~~~~~~~~~
    if(Magic<0){
        if(OrderSelect0(Magic,'m')>=Sel_Max){Magic=0;}}
    if(Magic<0){
        Str_Magic="Sell_Magic= "+DoubleToStr(Magic,0);
        Ans=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,
        0,0,Str_Magic,Magic,0,Red);
    }
//~~~~~~~~~~
return(Ans);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~Order_Select-Function
double OrderSelect0(int Magic,int Switch){
    for(i=OrdersTotal()-1;i>=0;i--){
        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true
            && OrderSymbol()==Symbol()){
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            switch(Switch){
                case 'm':   if(OrderMagicNumber()==Magic){Ans++;break;}
                case 'a':   if(OrderMagicNumber()==Magic){
                                OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),
                                Slippage,White);break;}
                case 't':   if(Switch=='t'){
                                OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),
                                Slippage,White);break;}
            }
    }}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
return(Ans);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~